<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
	/**
	 * Run the migrations.
	 *
	 * @return void
	 */
	public function up()
	{
		Schema::create('service__change', function(Blueprint $table)
		{
			$table->id();
			$table->timestamps();
			$table->boolean('active')->default(false);
			$table->integer('site_id')->unsigned();

			$table->boolean('complete')->default(false);
			$table->date('ordered_at');
			$table->date('effective_at')->nullable();
			$table->text('notes')->nullable();

			$table->integer('product_id')->unsigned();
			$table->foreign(['product_id','site_id'])->references(['id','site_id'])->on('products');

			$table->integer('service_id')->unsigned();
			$table->foreign(['service_id','site_id'])->references(['id','site_id'])->on('services');

			$table->integer('ordered_by')->unsigned();
			$table->foreign(['ordered_by','site_id'])->references(['id','site_id'])->on('users');

			$table->unique(['id','site_id']);
		});
	}

	/**
	 * Reverse the migrations.
	 *
	 * @return void
	 */
	public function down()
	{
		Schema::drop('service__change');
	}
};